program sokoban;

uses crt;

type tbod = record x,y : integer; end;

const levelno : integer = 1;

var map : array[1..13,1..13] of integer;
    best,opt : array[1..34] of integer;
    ja : tbod;
    kocky,fleky : array[1..3] of tbod;
    rows,cols,done : integer;
    moves : array[1..1000,1..2] of integer;
    nmoves : integer;

function int2str(i : integer) : string;
var s : string;
begin str(i,s); int2str:=s; end;
function lname : string; begin lname:='moj.'+int2str(levelno); end;

procedure readbest;
var f : text;
    i : integer;
begin
   assign(f,'best.dat'); reset(f);
   for i:=1 to 34 do readln(f,best[i]);
   close(f);
   assign(f,'optimal.dat'); reset(f);
   for i:=1 to 34 do readln(f,opt[i]);
   close(f);
{   for i:=1 to 34 do best[i]:=maxint;}
end;

procedure writebest;
var f : text;
    i : integer;
begin
   assign(f,'best.dat'); rewrite(f);
   for i:=1 to 34 do writeln(f,best[i]);
   close(f);
end;

procedure loadlevel;
var f : text;
    c : char;
    i,j,kk,ff : integer;

begin
   assign(f,lname); reset(f);
   i:=0; kk:=0; ff:=0; done:=0;
   while not eof(f) do begin
      inc(i); j:=0;
      while not eoln(f) do begin
         inc(j);
         read(f,c); 
         if c='#' then map[i,j]:=1 else map[i,j]:=0;
         if c='@' then begin ja.x:=i; ja.y:=j; end;
         if c='$' then begin
            inc(kk); kocky[kk].x:=i; kocky[kk].y:=j; map[i,j]:=map[i,j] or 2;
         end;
         if c='.' then begin
            inc(ff); fleky[ff].x:=i; fleky[ff].y:=j; map[i,j]:=map[i,j] or 4;
         end;
         if c='*' then begin
            inc(kk); kocky[kk].x:=i; kocky[kk].y:=j; map[i,j]:=map[i,j] or 2;
            inc(ff); fleky[ff].x:=i; fleky[ff].y:=j; map[i,j]:=map[i,j] or 4;
            inc(done);
         end;
      end;
      readln(f);
      cols:=j;
   end;
   rows:=i;
   close(f);
end;

procedure cwrite(i,j : integer; s : string; c : integer);
var k : integer;
begin
  gotoxy(j-1,i-1); 
  textattr:=c; 
  write(s);
{  for k:=1 to length(s) do begin
   mem[$b800:160*(i-1)+2*(j-1+k)]:=ord(s[k]);
   mem[$b800:160*(i-1)+2*(j-1+k)+1]:=c;
  end;}
end;

procedure drawaround;
var i,j : integer;
begin
   clrscr;
   cwrite(2,20,'SOKOBAN - MisoF.''s autogenerated level #',white);
   cwrite(2,20,'SOKOBAN',lightcyan);
   cwrite(2,30,'MisoF.',lightblue);
   cwrite(2,60,int2str(levelno),yellow);
   if best[levelno]<maxint then begin
      cwrite(3,20,'       best solution so far : ',white);
      if best[levelno]=opt[levelno] then
         cwrite(3,50,int2str(best[levelno]),lightgreen)
      else
         cwrite(3,50,int2str(best[levelno]),lightred);
      cwrite(4,20,'      best solution possible : ',white);
      cwrite(4,51,int2str(opt[levelno]),lightgreen);
   end else begin
      cwrite(3,20,'    this level hasn''t been solved yet',white);
   end;
   cwrite(6,3,'- ESC : restart level',lightgray);
   cwrite(7,3,'- U,BkSp : undo last move',lightgray);
   cwrite(8,3,'- arrow keys : move',lightgray);
   cwrite(9,3,'- Q : quit game',lightgray);
   cwrite(10,3,'- ^L : next level',lightgray);
   cwrite(11,3,'- ^K : previous level',lightgray);
   cwrite(13,3,'Solved levels :',white);
   cwrite(14,3,'  0123456789',lightgray);
   cwrite(15,3,'00 ---------',lightgray);
   cwrite(16,3,'10----------',lightgray);
   cwrite(17,3,'20----------',lightgray);
   cwrite(18,3,'30-----     ',lightgray);
{   cwrite(19,3,'40----------',lightgray);
   cwrite(20,3,'50---       ',lightgray);}
   for i:=1 to 34 do begin
     if levelno=i then 
      if best[i]<maxint then j:=yellow else j:=lightred
     else
      if best[i]<maxint then j:=lightgreen else j:=darkgray;
      if best[i]=opt[i] then
{         cwrite(15+i div 10,5+i mod 10,chr(2),j)}
         cwrite(15+i div 10,5+i mod 10,'!',j)
      else
{         cwrite(15+i div 10,5+i mod 10,chr(1),j);}
         cwrite(15+i div 10,5+i mod 10,'?',j);
   end;
end;

procedure drawlevel;
var i,j,k : integer;
begin
   for i:=1 to rows do begin
      for j:=1 to cols do begin
         if (ja.x=i) and (ja.y=j) then begin cwrite(i+5,j+35,'@',10); continue; end;
         if map[i,j] and 6=6 then begin cwrite(i+5,j+35,'o',lightred); continue; end;
         if map[i,j] and 2=2 then begin cwrite(i+5,j+35,'o',15); continue; end;
         if map[i,j] and 4=4 then begin cwrite(i+5,j+35,'x',lightred); continue; end;
         if map[i,j]=1 then cwrite(i+5,j+35,'#',lightgray) else cwrite(i+5,j+35,' ',white);
      end;
   end;
   cwrite(6,60,'Moves : ',lightgray);
   cwrite(6,68,int2str(nmoves)+'   ',white);
end;

function move(dx,dy : integer) : boolean;
var k : integer;
begin
   if map[ja.x+dx,ja.y+dy] and 1=1 then begin move:=false; exit; end;
   if map[ja.x+dx,ja.y+dy] and 2=0 then begin
      ja.x:=ja.x+dx; ja.y:=ja.y+dy; move:=true; exit;
   end;
   {je tam kocka - mozem ju pushnut ?}
   if map[ja.x+2*dx,ja.y+2*dy] and 3=0 then begin
      {push}
      for k:=1 to 3 do if (kocky[k].x=ja.x+dx) and (kocky[k].y=ja.y+dy) then break;
      kocky[k].x:=kocky[k].x+dx;
      kocky[k].y:=kocky[k].y+dy;
      map[ja.x+dx,ja.y+dy]:=map[ja.x+dx,ja.y+dy] and not 2;
      map[ja.x+2*dx,ja.y+2*dy]:=map[ja.x+2*dx,ja.y+2*dy] or 2;
      {update done}
      if map[ja.x+dx,ja.y+dy] and 4=4 then dec(done);
      if map[ja.x+2*dx,ja.y+2*dy] and 4=4 then inc(done);
      {move}
      ja.x:=ja.x+dx; ja.y:=ja.y+dy;
      move:=true;
   end else move:=false;
end;

procedure undo;
var i : integer;
begin
   loadlevel;
   for i:=1 to nmoves-1 do move(moves[i,1],moves[i,2]);
   dec(nmoves);
end;

procedure playlevel;
var c : char;
begin
   nmoves:=0;
   loadlevel;
   drawaround;
   drawlevel;
   repeat
      c:=upcase(readkey); if c=#0 then begin
         c:=readkey; case c of
            #72 : c:='E'; #75 : c:='S'; #77 : c:='D'; #80 : c:='X';
         else c:='!';
         end;
      end;
      case c of
         #11 : begin levelno:=levelno-2; if levelno=-1 then levelno:=0; exit; end; 
                     {prev level :)}
         #12 : exit; {next level :)}
         #27 : begin nmoves:=0; loadlevel; drawlevel; end;
         'Q' : begin textcolor(lightgray); clrscr; writebest; halt; end;
         #8,'U' : begin {undo}
            if nmoves>0 then begin
               undo;
               drawlevel;
            end;
         end;
         'E' : if move(-1,0) then begin 
            inc(nmoves); moves[nmoves,1]:=-1; moves[nmoves,2]:=0;
            drawlevel;
         end;
         'S' : if move(0,-1) then begin
            inc(nmoves); moves[nmoves,1]:=0; moves[nmoves,2]:=-1;
            drawlevel;
         end;
         'D' : if move(0,1) then begin
            inc(nmoves); moves[nmoves,1]:=0; moves[nmoves,2]:=1;
            drawlevel;
         end;
         'X' : if move(1,0) then begin
            inc(nmoves); moves[nmoves,1]:=1; moves[nmoves,2]:=0;
            drawlevel;
         end;
      end;
   until done=3;
   if best[levelno]>nmoves then best[levelno]:=nmoves;
end;

begin
   clrscr;
   readbest;
   repeat
      playlevel;
      inc(levelno);
   until levelno>34;
   writebest;
end.
